
From: Christoph Lameter <clameter@sgi.com>

Report the resolution of the time source correctly for time interpolators
with a frequency over 1 Ghz.

Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/kernel/timer.c |    5 ++++-
 1 files changed, 4 insertions(+), 1 deletion(-)

diff -puN kernel/timer.c~time-interpolators-logic-fix kernel/timer.c
--- 25/kernel/timer.c~time-interpolators-logic-fix	2004-09-15 22:11:01.900564672 -0700
+++ 25-akpm/kernel/timer.c	2004-09-15 22:11:01.904564064 -0700
@@ -1494,7 +1494,10 @@ void time_interpolator_reset(void)
 
 unsigned long time_interpolator_resolution(void)
 {
-	return NSEC_PER_SEC / time_interpolator->frequency;
+	if (time_interpolator->frequency < NSEC_PER_SEC)
+		return NSEC_PER_SEC / time_interpolator->frequency;
+	else
+		return 1;
 }
 
 #define GET_TI_NSECS(count,i) ((((count) - i->last_counter) * i->nsec_per_cyc) >> i->shift)
_
